#ifndef MAINWINDOW
#define MAINWINDOW
//---------------------------------------------------------------------
#include <Be.h>
#include <be/net/socket.h>
//---------------------------------------------------------------------
#define MAINWINDOW_TITLE 			"Network"
#define MAINWINDOW_POSITION_LEFT	100
#define MAINWINDOW_POSITION_TOP		100
#define MAINWINDOW_POSITION_WIDTH	400
#define MAINWINDOW_POSITION_HEIGHT	128
#define MAINWINDOW_WINDOWSTYLE      (B_TITLED_WINDOW)
//---------------------------------------------------------------------
#define MSG_CONNECT 'cnnb'
#define MSG_LISTEN  'lstb'
#define MSG_SEND    'sndb'
#define MSG_CLOSED  'clsd'
#define MSG_RECV    'recv'
//---------------------------------------------------------------------
struct RecThreadData
{
	int sock;
	BWindow *owner;
};
//---------------------------------------------------------------------
class BAppMainView : public BView
{
public:
	BStringView *strview;
	BTextControl *textctrl;
	BButton *connectbtn;
	BButton *listenbtn;
	BButton *sendbtn;
	BAppMainView(BRect frame);
};
//---------------------------------------------------------------------
class BAppMainWindow : public BWindow
{
private:
    int nsock;
	int32 recthread;
	char threadname[32];
public:
	BAppMainView *mainview;
	//-----------------------------------------------------------------
	BAppMainWindow(BRect frame,const char *title);
	virtual void MessageReceived(BMessage *msg);
	//-----------------------------------------------------------------
	bool QuitRequested();
	//-----------------------------------------------------------------
	void sock_connect(void);
    void sock_listen(void);
    void sock_send(void);
	void sock_closed(void);
	void sock_recv(void);
};
//---------------------------------------------------------------------
#endif
